;Sample POOL code, you may use it, modify it
;and distribute it under the GPL license.
;Authors: R&D Independent Team
;Source: www.pool-rnd.com

shared [g wx wy v step rate nmax]

"nmax := 200 "rate := 50
"nmaxs := (slider "|n max| {6 10} {10 500 1} :nmax)
setonchange :nmaxs ["nmax := getvalue :nmaxs]

"wx := 2 "wy := 0
"wxs := (slider "wind {6 70} {-10 10 0.1} :wx)
setonchange :wxs ["wx := getvalue :wxs]

"step := 0.3
"steps := (slider "step {6 130} {0.01 0.5 0.01} :step)
setonchange :steps ["step := getvalue :steps]

"g := 8.9
"v := 0.3
window
ht pu
setturtleimg "blue_dot_small
setxy :pool_inf,"wall_left + 150 ~
      :pool_inf,"wall_bottom + 50

to model
  let "mass (0.1 + runif 0.9)^2
  let "vx 40 + (runif -10 10)
  let "vy 100  + (runif -50 50)
  let "fx 0
  let "fy 0
  st

  to onsignalstep
    "fx := :wx - :v * :vx
    "fy := :wy - :v * :vy - :g / :mass
    "vx += :fx * :step
    "vy += :fy * :step
    setxy xcor + :vx * :step ycor + :vy * :step
    if ycor < :ymin [destroy]
  end

  let "ymin :pool_inf,"wall_bottom
  to onworldchanged :walls
    "ymin := :walls,4
  end
end

"t := timer [
  let "k :rate * :step
  let "n round (rnorm :k sqrt :k)
  let "c count children
  if :n + :c > :nmax ["n := :nmax - :c]
  if :n > 0 [let "m (newturtles :n $model)]
  signal "step
] 20

